from pytest_alembic import MigrationContext

from sqlalchemy_declarative_extensions.dialects import get_default_grants, get_roles


def test_apply_autogenerated_revision(alembic_runner: MigrationContext, alembic_engine):
    result = alembic_runner.generate_revision(
        autogenerate=True, prevent_file_generation=False
    )
    alembic_runner.migrate_up_one()

    with alembic_engine.connect() as conn:
        result = [r.name for r in get_roles(conn, exclude=["user"])]
    assert result == []

    with alembic_engine.connect() as conn:
        default_grants = get_default_grants(conn)
    assert default_grants == []
