from pytest_alembic import MigrationContext
from sqlalchemy import text


def test_apply_autogenerated_revision(alembic_runner: MigrationContext, alembic_engine):
    alembic_runner.migrate_up_to("head")

    # Ensure we actually inserted the rows at the correct revision.
    with alembic_engine.connect() as conn:
        result = conn.execute(text("select * from tab")).fetchall()

    expected_result = [
        (1, 1),
        (2, 2),
    ]
    assert expected_result == result
